unit Personal; { By Nicola Ferrando, 10/04/96 }

interface

{$B-,I-,R-,S-}
{$M 1024,0,0}

uses Crt, Dos;

{ Tipo e costanti per Box }
type
  FrameChars = array[1..6] of Char;
const
  SF: FrameChars = 'Ŀ'; { SingleFrame: riga singola }
  DF: FrameChars = 'ͻȼ'; { DoubleFrame: riga doppia }

{ Variabili per GetCursor/SetCursor }
var
  CursorOff, CursorUnderline, CursorHalfBlock, CursorBlock: Word;

function IsFile(FileName: PathStr): Boolean;
function IsDir(FileName: DirStr): Boolean;
function IsDrive(Drive: Char): Boolean;
function UpperStr(S: String): String;
function IP(L: Longint): String;
function LZ(W: Word): String;
function Yes: Boolean;
procedure Pause;
procedure ShowDosError;
procedure WriteXY(X, Y: Byte; S: String{80});
procedure BS(S: String);
procedure CenterLn(S: String);
procedure WriteChar(X, Y, Count: Byte; Ch: Char; Attr: Byte);
procedure WriteStr(X, Y: Byte; S: String; Attr: Byte);
procedure Box(X1, Y1, X2, Y2: Byte; Frame: FrameChars; Color: Byte);
function GetCursor: Word;
procedure SetCursor(Curs: Word);

implementation

var Regs: Registers;

{ funzioni }

function IsFile(FileName: PathStr): Boolean;
  { Restituisce True se il nome passato corrisponde a quello di un file. }
var
  F: File;
  Attr: Word;
begin
  Assign(F, FileName);
  GetFAttr(F, Attr);
  IsFile := (FileName <> '') and (DosError = 0) and
    ((Attr and Directory = 0) or (Attr and VolumeID = 0));
end;

function IsDir(FileName: DirStr): Boolean;
  { Restituisce True se il nome passato corrisponde a quello di una directory. }
var
  F: File;
  Attr: Word;
begin
  IsDir := True;
  if (Length(FileName) = 3) and (FileName[Length(FileName)] = '\') then Exit;
  if FileName[Length(FileName)] = '\' then Dec(FileName[0]);
  Assign(F, FileName);
  GetFAttr(F, Attr);
  IsDir := (FileName <> '') and (DosError = 0) and (Attr and Directory <> 0);
end;

function IsDrive(Drive: Char): Boolean;
  { Restituisce True se il drive esiste, altrimenti, restituisce False. }
var
  S: String[3];
begin
  IsDrive := False;
  Drive := UpCase(Drive);
  if not (Drive in ['A'..'Z']) then Exit;
  GetDir(Ord(Drive) - 64, S);
  IsDrive := S <> '';
end;

function UpperStr(S: String): String;
  { Trasforma in maiuscolo una stringa }
var
  I: Integer;
  SLen: Byte absolute S;
begin
  for I := 1 to SLen do S[I] := UpCase(S[I]);
  UpperStr := S;
end;

function IP(L: LongInt): String;
  { InsertPoint: trasforma un numero in una stringa con i punti delle migliaia }
var
  Temp1, Temp2: String[11];
begin  { function NumWithCommas }
  Temp1 := '';  { initializza la stringa di lavoro }
  while L >= 1000 do { inserimento di uno o pi punti }
  begin
    Str(L mod 1000, Temp2);  { inserisce le ultime 3 cifre di L in Temp2 }
    while Length(Temp2) < 3 do Temp2 := '0' + Temp2;
      { riempie Temp2 con zeri sulla sinistra }
    Temp1 := '.' + Temp2 + Temp1;
      { aggiunge il punto e le cifre alla stringa di lavoro }
    L := L div 1000; { scarta le 3 cifre appena processate }
  end; { ora L  minore di 1.000 }
  Str(L, Temp2);
  IP := Temp2 + Temp1; { insersice le prime cifre all'inizio }
end;

function LZ(W: Word): String;
  { LeadingZero: aggiunge uno zero all'inizio prima del numero se necessario }
var S: String[2];
begin
  Str(W:0,S);
  if Length(S) = 1 then S := '0' + S;
  LZ := S;
end;

function Yes: Boolean;
  { Gestisce le risposte di tipo S/No }
var
  Ch: Char;
begin
  repeat
    Ch := UpCase(ReadKey);
  until Ch in [#13,#27,#78,#83];
  case Ch of
    #13,#83:
    begin
      Yes := True;
      WriteLn('S');
    end;
    #27,#78:
    begin
      Yes := False;
      WriteLn('N');
    end;
  end;
end;

{ procedure }

procedure Pause;
  { Blocca l'esecuzione finch non si preme un tasto }
begin
  Write('Premere un tasto per continuare... ');
  repeat until ReadKey <> #0;
end;

procedure ShowDosError;
  { Mostra il messaggio corrispondente all'errore Dos }
begin
  Write('Codice di errore Dos = ',DosError,' ');
  case DosError of
    2: WriteLn('(file non trovato)');
    3: WriteLn('(percorso non trovato)');
    4: WriteLn('(troppi files aperti)');
    5: WriteLn('(accesso negato)');
    6: WriteLn('(handle non valido)');
    8: WriteLn('(memoria insufficiente)');
    10: WriteLn('(ambiente non valido)');
    11: WriteLn('(formato non valido)');
    15: WriteLn('(drive non valido)');
    18: WriteLn('(non ci sono altri files)');
    19: WriteLn('(drive protetto da scrittura)');
    21: WriteLn('(drive non pronto)');
    23: WriteLn('(errore nel CRC dei dati)');
    29: WriteLn('(errore di scrittura)');
    30: WriteLn('(errore di lettura)');
    32: WriteLn('(violazione di condivisione)');
    33: WriteLn('(violazione di blocco)');
  end;
  Pause;
end;

procedure WriteXY(X, Y: byte; S: String);
  { Scrive un messaggio nella posizione specificata }
begin
  if (X in [1..Lo(WindMax)+1]) and (Y in [1..Hi(WindMax)+1]) then
  begin
    GotoXY(X,Y); Write(S);
  end else RunError(201);
end;

procedure BS(S: string);
  { BrightString: scrive una stringa luminosa }
begin
  HighVideo;
  Write(S);
  LowVideo;
end;

procedure CenterLn(S: String);
  { Centra una stringa sulla riga corrente }
begin
  if Length(S) > Lo(WindMax) then Exit;
  GotoXY((Lo(WindMax) div 2) - (Length(S) div 2), WhereY); WriteLn(S);
end;

{ Procedure che usano la memoria video }

{$L DVWrite}
procedure WriteChar(X, Y, Count: Byte; Ch: Char; Attr: Byte); External;
  { Scrive Count caratteri a partire dalla posizione X,Y con colore Attr }
procedure WriteStr(X, Y: Byte; S: String; Attr: Byte); External;
  { Scrive una stringa a partire dalla posizione X,Y con colore Attr }

procedure Box(x1, y1, x2, y2: byte; Frame: FrameChars; Color: Byte);
  { Disegna una finestra con contorno singolo (SF) o doppio (DF) con colori Color }
var I, J: Integer;
begin
  WriteChar(X1, Y1, 1, Frame[1], Color);
  WriteChar(X1+1, Y1, X2-X1-1, Frame[2], Color);
  WriteChar(X2, Y1, 1, Frame[3], Color);
  for I := Y1+1 to Y2-1 do
  begin
    WriteChar(X1, I, 1, Frame[4], Color);
    for J := X1+1 to X2-1 do WriteChar(J, I, 1, #32, Color);
    WriteChar(X2, I, 1, Frame[4], Color);
  end;
  WriteChar(X1, Y2, 1, Frame[5], Color);
  WriteChar(X1+1, Y2, X2-X1-1, Frame[2], Color);
  WriteChar(X2, Y2, 1, Frame[6], Color);
  Window(x1+1, y1+1, x2-1, y2-1);
  TextAttr := Color;
end;

{ Funzioni e proceudre per la gestione del cursore }

function GetCursor: Word;
  { Restituisce la dimensione del cursore }
begin
  GetCursor := (Mem[$0040:$0060] shl 4) + Mem[$0040:$0061];
end;

procedure SetCursor(Curs: Word);
  { Modifica la dimensione del curosre }
begin
  Regs.ah := $01;
  Regs.ch := Curs mod 16;
  Regs.cl := Curs div 16;
  Intr($10, Regs);
end;

begin { Inizializzazione variabili cursore }
  Intr($11, Regs);
  case (Regs.al and $30) shr 4 of
    1: { video mono }
    begin
      CursorUnderline := 203; { 11-12 }
      CursorHalfBlock := 198; { 6-12 }
      CursorBlock := 193;     { 1-12 }
      CursorOff := 1;         { 0- 1 }
    end;
    2: { video colore }
    begin
      CursorUnderline := 118; { 6-7 }
      CursorHalfBlock := 116; { 4-7 }
      CursorBlock := 113;     { 1-7 }
      CursorOff := 1;         { 0-1 }
    end;
  end;
end.
